# class Prism::OptionalKeywordParameterNode

Represents an optional keyword parameter to a method, block, or lambda definition.

    def a(b: 1)
          ^^^^
    end

### Attributes

name [R]

attr_reader name: `Symbol`

value [R]

attr_reader value: Prism::node

### Public Class Methods

new (source, node_id, location, flags, name, name_loc, value)
Source

    # File lib/prism/node.rb, line 13816
    def initialize(source, node_id, location, flags, name, name_loc, value)
      @source = source
      @node_id = node_id
      @location = location
      @flags = flags
      @name = name
      @name_loc = name_loc
      @value = value
    end

Initialize a new `OptionalKeywordParameterNode` node.

type ()
Source

    # File lib/prism/node.rb, line 13894
    def self.type
      :optional_keyword_parameter_node
    end

Return a symbol representation of this node type. See ‘Node::type`.

### Public Instance Methods

=== (other)
Source

    # File lib/prism/node.rb, line 13900
    def ===(other)
      other.is_a?(OptionalKeywordParameterNode) &&
        (flags === other.flags) &&
        (name === other.name) &&
        (name_loc.nil? == other.name_loc.nil?) &&
        (value === other.value)
    end

Implements case-equality for the node. This is effectively == but without comparing the value of locations. Locations are checked only for presence.

accept (visitor)
Source

    # File lib/prism/node.rb, line 13827
    def accept(visitor)
      visitor.visit_optional_keyword_parameter_node(self)
    end

def accept: (`Visitor` visitor) -> void

child_nodes ()
Source

    # File lib/prism/node.rb, line 13832
    def child_nodes
      [value]
    end

def `child_nodes`: () -> Array[nil | Node]

Also aliased as: deconstruct
comment_targets ()
Source

    # File lib/prism/node.rb, line 13842
    def comment_targets
      [name_loc, value] #: Array[Prism::node | Location]
    end

def `comment_targets`: () -> Array[Node | Location]

compact_child_nodes ()
Source

    # File lib/prism/node.rb, line 13837
    def compact_child_nodes
      [value]
    end

def `compact_child_nodes`: () -> Array

copy (node_id: self.node_id, location: self.location, flags: self.flags, name: self.name, name_loc: self.name_loc, value: self.value)
Source

    # File lib/prism/node.rb, line 13847
    def copy(node_id: self.node_id, location: self.location, flags: self.flags, name: self.name, name_loc: self.name_loc, value: self.value)
      OptionalKeywordParameterNode.new(source, node_id, location, flags, name, name_loc, value)
    end

def copy: (?node_id: `Integer`, ?location: `Location`, ?flags: `Integer`, ?name: `Symbol`, ?name_loc: `Location`, ?value: Prism::node) -> `OptionalKeywordParameterNode`

deconstruct ()

def deconstruct: () -> Array[nil | Node]

Alias for: child_nodes
deconstruct_keys (keys)
Source

    # File lib/prism/node.rb, line 13855
    def deconstruct_keys(keys)
      { node_id: node_id, location: location, name: name, name_loc: name_loc, value: value }
    end

def `deconstruct_keys`: (Array keys) -> { node_id: `Integer`, location: `Location`, name: `Symbol`, `name_loc`: `Location`, value: Prism::node }

inspect ()
Source

    # File lib/prism/node.rb, line 13884
    def inspect
      InspectVisitor.compose(self)
    end

def inspect -> `String`

name_loc ()
Source

    # File lib/prism/node.rb, line 13868
    def name_loc
      location = @name_loc
      return location if location.is_a?(Location)
      @name_loc = Location.new(source, location >> 32, location & 0xFFFFFFFF)
    end

attr_reader `name_loc`: `Location`

repeated_parameter? ()
Source

    # File lib/prism/node.rb, line 13860
    def repeated_parameter?
      flags.anybits?(ParameterFlags::REPEATED_PARAMETER)
    end

def repeated_parameter?: () -> bool

save_name_loc (repository)
Source

    # File lib/prism/node.rb, line 13876
    def save_name_loc(repository)
      repository.enter(node_id, :name_loc)
    end

Save the `name_loc` location using the given saved source so that it can be retrieved later.

type ()
Source

    # File lib/prism/node.rb, line 13889
    def type
      :optional_keyword_parameter_node
    end

Return a symbol representation of this node type. See ‘Node#type`.